//
//  ShopDetaileViewController.m
//  XFFruit
//
//  Created by mac on 15/8/19.
//  Copyright (c) 2015年 Xummer. All rights reserved.
//

#import "ShopDetaileViewController.h"
#import "SurveyCell.h"
#import "HPGrowingTextView.h"
#import "StartTimeView.h"
#import "ChosePersonViewController.h"
#import "ChooseProductViewController.h"
#import "ChooseProductUnitViewController.h"
#import "GXFSearchVendorViewController.h"
#import "GXFProductUnit.h"
#define LeftMargin 15
#define BtnHeight 44
#define TableHeight 46
#define CornerRadius 5
#define TitleSize 15
#define BtnSize 19
#define TotalHeight 432
#define KeyboardHeight 258
#define DateViewHeight 300
typedef enum : NSUInteger {
    SaveTag = 2000,
    CommitTag,
} BtnTag;
@interface ShopDetaileViewController ()<UITableViewDataSource,UITableViewDelegate,HPGrowingTextViewDelegate,UITextFieldDelegate,UIAlertViewDelegate>
{
    UITableView *_tableView;
    NSMutableArray *_dataArr;
    UILabel *_productLabel;
    UILabel *_PackagingLable;
    UITextField *packageSpecification;//包装规格
    UITextField *packageQuantity;     //包装数量
    UITextField *foundationQuantity;  //基础数量
    UITextField *foundationUnitPrice; //基础单价
    UITextField *packageUnitPrice;    //包装单价
    UITextField *totalMoney;          //总金额
    HPGrowingTextView *remark;        //备注
    UILabel *_measureUnitLabel;  //默认规格单位
    UILabel *_packageCountLabel; //包装数量
    UILabel *_baseCountLabel;    //基础数量

}
@property (nonatomic,strong)NSString *productCodeStr;//商品代码
@property (nonatomic,strong)NSString *productNameStr;//商品名字
@property (nonatomic,strong)NSString *productUuidStr;//商品code
@property (nonatomic,strong)NSString *productMeasureUnit;//默认规格单位
@property (nonatomic,strong)NSString *packageQpcStr;    //规格描述
@property (nonatomic,strong)NSString *packageUintStr;    //包装单位
@property (nonatomic,strong)NSMutableArray *selectProducts;
@property (nonatomic,strong)NSString *selectUnit;

@end

@implementation ShopDetaileViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.title = self.navTitle;
    [self initData];
    [self setupSubviews];
}
- (void)initData{
    _dataArr = [NSMutableArray array];
    self.selectProducts = [NSMutableArray array];
    [_dataArr addObject:@"商品"];
    [_dataArr addObject:@"包装单位"];
    [_dataArr addObject:@"包装规格"];
    [_dataArr addObject:@"包装数量"];
    [_dataArr addObject:@"基础数量"];
    [_dataArr addObject:@"基础单价"];
    [_dataArr addObject:@"包装单价"];
    [_dataArr addObject:@"总金额"];
    [_dataArr addObject:@"备注"];
    
}

-(void)setupSubviews
{    
    _tableView = [[UITableView alloc]initWithFrame:(CGRectMake(0, 0,ScreenSize.width, ScreenSize.height - 64 - LeftMargin)) style:(UITableViewStylePlain)];
    _tableView.backgroundColor = [UIColor whiteColor];
    _tableView.bounces = NO;
    _tableView.delegate = self;
    _tableView.dataSource = self;
    
    UIView *footView = [[UIView alloc]initWithFrame:CGRectMake(0, 0, ScreenSize.width, 50)];
    
    UIButton *saveBtn =  [IBTCustomButtom creatButtonWithFrame:CGRectMake(LeftMargin, 10, (ScreenSize.width - LeftMargin*3)/2, BtnHeight) target:self sel:@selector(btnClick:) tag:SaveTag image:nil title:@"删除" titleColor: [UIColor whiteColor] isCorner:YES corner:CornerRadius bgColor:GXF_SAVE_COLOR];
    [footView addSubview:saveBtn];
    
    UIButton *commitBtn = [IBTCustomButtom creatButtonWithFrame:CGRectMake(saveBtn.frame.origin.x + saveBtn.frame.size.width + LeftMargin, 10, (ScreenSize.width - LeftMargin*3)/2, BtnHeight) target:self sel:@selector(btnClick:) tag:CommitTag image:nil title:@"保存" titleColor: [UIColor whiteColor] isCorner:YES corner:CornerRadius bgColor:GXF_COMMIT_COLOR];
    [footView addSubview:commitBtn];
        _tableView.tableFooterView = footView;
    [self.view addSubview:_tableView];
    
}
- (void)setviewsData
{
    if (self.shopDetail!=nil) {
        
        //商品
        _productLabel.text = [NSString stringWithFormat:@"%@[%@]",self.shopDetail.merchandise,self.shopDetail.product_code];
        [self.selectProducts addObject:_shopDetail.product_uuid];
        //包装单位
        _PackagingLable.text = self.shopDetail.packageUnit;
        _packageCountLabel.text = self.shopDetail.packageUnit;
        self.selectUnit = self.shopDetail.packageUnit;
        
        //包装规格
        packageSpecification.text=self.shopDetail.packageSpecification;
        
        //包装规格单位
        self.shopDetail.packageQpcUnit ? (_measureUnitLabel.text =  self.shopDetail.packageQpcUnit) : (_measureUnitLabel.text = @"斤");
        self.shopDetail.packageQpcUnit ? (_baseCountLabel.text =  self.shopDetail.packageQpcUnit) : (_baseCountLabel.text = @"斤");
        
        //包装数量
        packageQuantity.text=self.shopDetail.packageQuantity;
        //基础数量
        foundationQuantity.text=self.shopDetail.foundationQuantity;
        //基础单价
        foundationUnitPrice.text=self.shopDetail.foundationUnitPrice;
        //包装单价
        packageUnitPrice.text=self.shopDetail.packageUnitPrice;
        //总金额
        totalMoney.text=self.shopDetail.totalMoney;
        //备注
        remark.text=self.shopDetail.remark;
        
        _productLabel.textColor=GXF_CONTENT_COLOR;
        _PackagingLable.textColor=GXF_CONTENT_COLOR;
        
        self.productCodeStr = self.shopDetail.product_code;
        self.productUuidStr = self.shopDetail.product_uuid;
        self.productNameStr = self.shopDetail.merchandise;
        self.packageQpcStr =  self.shopDetail.packageQpcStr;
        self.packageUintStr = self.shopDetail.packageUnit;
        self.productMeasureUnit = self.shopDetail.packageQpcUnit.length > 0 ? self.shopDetail.packageQpcUnit : @"斤";
    }
}
#pragma mark - 按钮点击事件
- (void)btnClick:(UIButton *)btn{
    switch (btn.tag) {
        case SaveTag://删除
        {
            UIAlertView *alertView = [[UIAlertView alloc]initWithTitle:@"温馨提示" message:@"请确认删除" delegate:self cancelButtonTitle:@"取消" otherButtonTitles:@"确认", nil];
            alertView.delegate = self;
            [alertView show];
        }
            break;
        case CommitTag:
        {
            if ([self informationComplete]) {
                ShopDetail *shopDetail=self.shopDetail;
                shopDetail.IsDeleted=NO;
                self.choseShopDetail(shopDetail);//回调
                [self PopViewControllerAnimated:YES];
            }
        }
            break;
        default:
            break;
    }
}
- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex{
    if (buttonIndex == 1) {
        if (self.shopDetail!=nil) {
            ShopDetail *shopDetail=self.shopDetail;
            
            if (shopDetail.IsXiuGai==YES) {
                shopDetail.IsDeleted=YES;
                self.choseShopDetail(shopDetail);//回调
                [self PopViewControllerAnimated:YES];
            }else
            {
                [self  clearShopDetail];
            }
        }else
        {
            [self  clearShopDetail];
        }

    }
}

- (void)clearShopDetail
{
    _productLabel.text = @"选择商品";//商品
    
    _PackagingLable.text = @"选择包装单位";//包装单位
    packageSpecification.text = @"";//包装规格
    packageQuantity.text = @"";     //包装数量
    
    foundationQuantity.text = @"0";  //基础数量
    foundationUnitPrice.text = @""; //基础单价
    packageUnitPrice.text = @"0";    //包装单价
    totalMoney.text = @"0";          //总金额
    remark.text = @"";
    _productLabel.textColor=GXF_PLACEHOLDER_COLOR;
    _PackagingLable.textColor=GXF_PLACEHOLDER_COLOR;
}
- (BOOL)informationComplete{
    if (!self.shopDetail) {
        self.shopDetail=[[ShopDetail alloc]init];
    }
    self.shopDetail.product_code = self.productCodeStr;
    self.shopDetail.product_uuid = self.productUuidStr;
    self.shopDetail.merchandise = self.productNameStr;
    
    self.shopDetail.packageSpecification = packageSpecification.text;
    self.shopDetail.packageQpcStr = self.packageQpcStr;
    self.shopDetail.packageQpcUnit = self.productMeasureUnit;

    self.shopDetail.packageUnit = self.packageUintStr;
    self.shopDetail.packageQuantity = packageQuantity.text;
    self.shopDetail.packageUnitPrice = packageUnitPrice.text;

    self.shopDetail.foundationQuantity = foundationQuantity.text;
    self.shopDetail.foundationUnitPrice = foundationUnitPrice.text;
    
    self.shopDetail.totalMoney = totalMoney.text;
    self.shopDetail.remark = remark.text;
    
    if (self.productNameStr.length == 0 ) {
        ShowMessage(@"商品不能为空");
        return NO;
    }
    if (packageSpecification.text.length == 0 ) {
        ShowMessage(@"包装规格不能为空");
        return NO;
    }
    if (packageQuantity.text.length == 0 ) {
        ShowMessage(@"包装数量不能为空");
        return NO;
    }
    if (self.packageUintStr.length == 0) {
        ShowMessage(@"包装单位不能为空");
        return NO;
    }
    if (foundationQuantity.text.length == 0) {
        ShowMessage(@"基础数量不能为空");
        return NO;
    }
    if (foundationUnitPrice.text.length == 0) {
        ShowMessage(@"基础单价不能为空");
        return NO;
    }if (packageUnitPrice.text.length == 0) {
        ShowMessage(@"总金额不能为空");
        return NO;
    }
    
    if ([packageQuantity.text integerValue] <= 0 || [foundationQuantity.text integerValue] <= 0 || [packageSpecification.text integerValue] <= 0) {
        ShowMessage(@"商品数量不能为0");
        return NO;
    }
    if ([packageUnitPrice.text floatValue] <=0 || [foundationUnitPrice.text floatValue] <= 0 || [totalMoney.text floatValue]<= 0) {
        ShowMessage(@"商品价格不能0");
        return NO;
    }
    return YES;
}
#pragma mark - 协议方法
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return _dataArr.count;
}
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return TableHeight;
}
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *cellID = @"cellID";
    SurveyCell *cell = [tableView dequeueReusableCellWithIdentifier:cellID];
    if (cell == nil) {
        cell = [[SurveyCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellID];
        tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        if (indexPath.row==0||indexPath.row==1) {
            cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
        }
        [self createViewInCell:cell indexPath:indexPath];
    }
    [cell setTitleStr:_dataArr[indexPath.row]];
    return cell;
}

-  (void)createViewInCell:(SurveyCell *)cell indexPath:(NSIndexPath *)indexPath{
    if (indexPath.row == 0||indexPath.row==1) {
        UILabel *contentLabel = [[UILabel alloc]initWithFrame:(CGRectMake(100+LeftMargin, 0, ScreenSize.width - 100 - LeftMargin*2-15, TableHeight))];
        contentLabel.textAlignment= NSTextAlignmentRight;
        contentLabel.textColor = GXF_PLACEHOLDER_COLOR;
        contentLabel.font = FontSize(TitleSize);
        [cell.contentView addSubview:contentLabel];
        if (indexPath.row==0) {
            _productLabel = contentLabel;
            contentLabel.text = @"选择商品";
        }else if (indexPath.row==1)
        {
            _PackagingLable = contentLabel;
            contentLabel.text = @"选择包装单位";
        }
        
    }else if(indexPath.row == 8){
        HPGrowingTextView * remarkTextView = [[HPGrowingTextView alloc] initWithFrame:CGRectMake(100+LeftMargin, 0, ScreenSize.width - 100 - LeftMargin*2-15, TableHeight)];
        remarkTextView.contentInset = UIEdgeInsetsMake(5, 5, 5, 0);
        remarkTextView.minNumberOfLines = 1;
        remarkTextView.maxNumberOfLines = 1;
        remarkTextView.isScrollable = YES;
        remarkTextView.font = GXF_FIFTEENTEN_SIZE;
        remarkTextView.textAlignment = NSTextAlignmentRight;
        remarkTextView.delegate = self;
        remarkTextView.returnKeyType = UIReturnKeyDone;
        remarkTextView.placeholder = @"输入备注内容";
        [cell.contentView addSubview:remarkTextView];
        remark=remarkTextView;              //备注
    }else{
        UITextField  *textField = [[UITextField alloc] initWithFrame:CGRectMake(100+LeftMargin, 0, ScreenSize.width - 100 - LeftMargin*2-30, TableHeight)];
        textField.textAlignment = NSTextAlignmentRight;
        textField.textColor = GXF_CONTENT_COLOR;
        textField.font = FontSize(15);
        textField.returnKeyType = UIReturnKeyDone;
        textField.keyboardType = UIKeyboardTypeDecimalPad;
        textField.delegate = self;
        [cell.contentView addSubview:textField];
        
        UILabel *label = [[UILabel alloc]initWithFrame:CGRectMake(CGRectGetMaxX(textField.frame)+ 5, 0, 20, TableHeight)];
        label.textColor = GXF_CONTENT_COLOR;
        label.font = GXF_FIFTEENTEN_SIZE;
        [cell.contentView addSubview:label];
        
        if (indexPath.row==2) {
            UILabel *labelTwo = [[UILabel alloc]initWithFrame:CGRectMake(100+LeftMargin, 0, 50, TableHeight)];
            labelTwo.text = @"1*";
            labelTwo.textAlignment = NSTextAlignmentRight;
            [cell.contentView addSubview:labelTwo];
            textField.left = labelTwo.right;
            textField.width = textField.width - 50;
            label.left = textField.right+ 5;
            _measureUnitLabel = label;
            textField.placeholder = @"输入包装规格";
            [textField addTarget:self action:@selector(textChange:) forControlEvents:UIControlEventAllEditingEvents];
            packageSpecification=textField;//包装规格
            
        }else if (indexPath.row==3)
        {
            _packageCountLabel = label;
            textField.placeholder = @"输入包装数量";
            [textField addTarget:self action:@selector(textChange:) forControlEvents:UIControlEventAllEditingEvents];
            packageQuantity=textField;     //包装数量
        }else if (indexPath.row==4)
        {
            _baseCountLabel = label;
            [textField setEnabled:NO];
            textField.placeholder = @"基础数量";
            textField.textColor = [UIColor redColor];
            foundationQuantity=textField;  //基础数量
            
        }else if (indexPath.row==5)
        {
            label.text = @"元";
            textField.placeholder = @"输入基础单价";
            [textField addTarget:self action:@selector(textChange:) forControlEvents:UIControlEventAllEditingEvents];
            foundationUnitPrice=textField; //基础单价
        }else if (indexPath.row==6)
        {
            label.text = @"元";
            [textField addTarget:self action:@selector(textChange:) forControlEvents:UIControlEventAllEditingEvents];
            textField.placeholder = @"包装单价";
            packageUnitPrice=textField;    //包装单价
            
        }else if (indexPath.row==7)
        {
            label.text = @"元";
            [textField addTarget:self action:@selector(textChange:) forControlEvents:UIControlEventAllEditingEvents];
            textField.placeholder = @"总金额";
            textField.textColor = [UIColor redColor];
            totalMoney=textField;          //总金额
        }
    }
     [self  setviewsData];
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    
    if(indexPath.row == 0){
        ChooseProductViewController *cvc = [ChooseProductViewController new];
        if (self.selectProducts.count > 0) {
            cvc.selectArr = self.selectProducts;
        }
        cvc.choseBaseInfo = ^(NSArray  *products){
            Product *product=products [0];
            _productLabel.text = [NSString stringWithFormat:@"%@[%@]",product.name,product.code];
            _productLabel.textColor = GXF_CONTENT_COLOR;
            self.productNameStr = product.name;
            self.productUuidStr = product.uuid;
            self.productCodeStr = product.code;
            self.packageQpcStr = product.qpcStr;
            self.productMeasureUnit = product.measureUnit;
            if (self.selectProducts.count > 0) {
                [self.selectProducts removeAllObjects];
            }
            [self.selectProducts addObject:product.uuid];
            
            if (self.productMeasureUnit.length == 0) {
                _measureUnitLabel.text = @"斤";
                _baseCountLabel.text = @"斤";
            }else{
                _measureUnitLabel.text = self.productMeasureUnit;
                _baseCountLabel.text = self.productMeasureUnit;
            }
        };
        cvc.isMoreChose = NO;
        [self PushViewController:cvc animated:YES];
    }else if (indexPath.row ==1)
    {
        ChooseProductUnitViewController *cvc = [ChooseProductUnitViewController new];
        if (self.selectUnit.length > 0) {
            cvc.selectStr = self.selectUnit;
        }
        cvc.choseBaseInfo = ^(NSArray  *products){
            if (products.count > 0) {
                GXFProductUnit *productUnit=products [0];
                _PackagingLable.text = [NSString stringWithFormat:@"%@",productUnit.name];
                _PackagingLable.textColor = GXF_CONTENT_COLOR;
                _packageCountLabel.text = productUnit.name;
                self.packageUintStr = productUnit.name;
                self.selectUnit = productUnit.name;
            }
        };
        cvc.isMoreChose = NO;
        [self PushViewController:cvc animated:YES];
    }
}

#pragma mark - textFiled事件
- (void)textChange:(UITextField *)textField{
    //包装规格和包装数量
    if (textField == packageSpecification || textField == packageQuantity) {
        if (packageSpecification.text.length > 0 && packageQuantity.text.length > 0 ) {
            //计算基础数量  和 总金额和包装单价
            int baseCount = [packageSpecification.text intValue] * [packageQuantity.text intValue];
            foundationQuantity.text = [NSString stringWithFormat:@"%d",baseCount];
            //如果基础单价有  会计算出包装单价和总价
            //如果包装单价有 会计算出基础单价和总价
            [self setTotalMoney];
        }
    }else if(textField == foundationUnitPrice){
        //基础单价
        [self setPacktAndTotalPrice];
        //如果基础数量和包装数量有的话计算出包装单价和和总价
    }else if (textField == packageUnitPrice){
        //包装单价
        [self setUnitAndTotalPrice];
    }else if(textField == totalMoney){
        //总金额
        [self setUnitAndPackPrice];
    }
}

- (void)setTotalMoney{
    //计算总金额和包装单价
    [self setPacktAndTotalPrice];
    [self setUnitAndTotalPrice];
}
- (void)setPacktAndTotalPrice{
    if (foundationUnitPrice.text.length > 0) {
        if (foundationQuantity.text.length > 0) {
            float totalPrice = [foundationUnitPrice.text floatValue] * [foundationQuantity.text floatValue];
            totalMoney.text = [NSString stringWithFormat:@"%.2f",totalPrice];
            if (packageQuantity.text.length > 0 && [packageQuantity.text integerValue] > 0) {
                float packagePrice = totalPrice / [packageQuantity.text floatValue];
                packageUnitPrice.text = [NSString stringWithFormat:@"%.2f",packagePrice];
            }
        }
    }
}
//输入包装单价(包装数量和基础数量)计算基础单价和总金额
- (void)setUnitAndTotalPrice{
    if (packageUnitPrice.text.length > 0) {
        if (packageQuantity.text.length > 0) {
            float totalPrice = [packageUnitPrice.text floatValue] * [packageQuantity.text floatValue];
            totalMoney.text = [NSString stringWithFormat:@"%.2f",totalPrice];
            if (foundationQuantity.text.length > 0 && [foundationQuantity.text integerValue] > 0) {
                float packagePrice = totalPrice / [foundationQuantity.text floatValue];
                foundationUnitPrice.text = [NSString stringWithFormat:@"%.2f",packagePrice];
            }
        }
    }
}
//输入总金额（包装数量和基础数量）计算基础单价和包装单价
- (void)setUnitAndPackPrice{
    if (totalMoney.text.length > 0) {
        if (packageQuantity.text.length > 0 && [packageQuantity.text floatValue] > 0) {
            float packagePrice = [totalMoney.text floatValue] / [packageQuantity.text floatValue];
            packageUnitPrice.text = [NSString stringWithFormat:@"%.2f",packagePrice];
        }
        if (foundationQuantity.text.length > 0 && [foundationQuantity.text floatValue] > 0) {
            float packagePrice = [totalMoney.text floatValue] / [foundationQuantity.text floatValue];
            foundationUnitPrice.text = [NSString stringWithFormat:@"%.2f",packagePrice];
        }
    }
}
#pragma mark delegate
- (BOOL)growingTextViewShouldReturn:(HPGrowingTextView *)growingTextView{
    [remark resignFirstResponder];
    return YES;
}
- (void)keyboardHidden{
    [remark resignFirstResponder];
}

- (void)viewWillDisappear:(BOOL)animated{
    [super viewWillDisappear:animated];
    
}

/*
 #pragma mark - Navigation
 
 // In a storyboard-based application, you will often want to do a little preparation before navigation
 - (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
 // Get the new view controller using [segue destinationViewController].
 // Pass the selected object to the new view controller.
 }
 */

@end
